"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ListNode = void 0;
const Node_1 = require("./Node");
exports.ListNode = (children) => {
    return ({
        ...Node_1.Base,
        transform(path, value, view) {
            if (!(value instanceof Array))
                return value;
            return value.map((obj, index) => children.transform(path.push(index), obj, view));
        },
        render(path, value, view, options) {
            var _a;
            value = value !== null && value !== void 0 ? value : [];
            const onAdd = view.registerClick(el => {
                if (!(value instanceof Array))
                    value = [];
                view.model.set(path, [...value, children.default()]);
            });
            return `<div class="node list-node">
        <div class="node-header" ${path.error()}>
          ${(options === null || options === void 0 ? void 0 : options.removeId) ? `
            <button class="remove" data-id="${options === null || options === void 0 ? void 0 : options.removeId}">
              ${(options === null || options === void 0 ? void 0 : options.removeLabel) ? options === null || options === void 0 ? void 0 : options.removeLabel : ''}
            </button>
          ` : ``}
          <label>${path.locale()}</label>
          ${(_a = options === null || options === void 0 ? void 0 : options.inject) !== null && _a !== void 0 ? _a : ''}
          <button class="add" data-id="${onAdd}"></button>
        </div>
        ${!(value instanceof Array) ? `` :
                `<div class="node-body">
          ${(value !== null && value !== void 0 ? value : []).map((obj, index) => `<div class="node-entry">
            ${children.render(path.push(index), obj, view, {
                    removeId: view.registerClick(el => view.model.set(path.push(index), undefined)),
                    removeLabel: path.push('entry').locale()
                })}
          </div>`).join('')}
        </div>`}
      </div>`;
        },
        validate(path, value, errors) {
            value = value !== null && value !== void 0 ? value : [];
            if (!(value instanceof Array)) {
                errors.add(path, 'error.expected_list');
                return value;
            }
            return value.map((obj, index) => children.validate(path.push(index), obj, errors));
        }
    });
};
