"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.StringNode = void 0;
const Node_1 = require("./Node");
/**
 * Simple string node with one text field
 */
exports.StringNode = () => {
    return {
        ...Node_1.Base,
        default: () => '',
        render(path, value, view, options) {
            var _a;
            const onChange = view.registerChange(el => {
                const value = el.value;
                view.model.set(path, value);
            });
            return `<div class="node string-node node-header" ${path.error()}>
        ${(options === null || options === void 0 ? void 0 : options.removeId) ? `<button class="remove" data-id="${options === null || options === void 0 ? void 0 : options.removeId}"></button>` : ``}
        ${(options === null || options === void 0 ? void 0 : options.hideLabel) ? `` : `<label>${path.locale()}</label>`}
        ${(_a = options === null || options === void 0 ? void 0 : options.inject) !== null && _a !== void 0 ? _a : ''}
        <input data-id="${onChange}" value="${value !== null && value !== void 0 ? value : ''}">
      </div>`;
        },
        validate(path, value, errors) {
            if (typeof value !== 'string') {
                errors.add(path, 'error.expected_string');
            }
            return value;
        },
        getState(el) {
            return el.getElementsByTagName('input')[0].value;
        },
        renderRaw() {
            return `<input>`;
        }
    };
};
