import { DataModel, ModelListener } from "../model/DataModel";
import { Errors } from "../model/Errors";
export interface IView {
    setModel: (model: DataModel) => void;
}
export declare abstract class AbstractView implements ModelListener {
    model: DataModel;
    /**
     * @param model data model this view represents and listens to
     */
    constructor(model: DataModel);
    /**
     * Updates the data model that this view represents
     * @param newModel updated data model
     */
    setModel(newModel: DataModel): void;
    invalidated(model: DataModel): void;
    errors(errors: Errors): void;
}
